<?php

// uncomment the following to define a path alias
// Yii::setPathOfAlias('local','path/to/local-folder');

// This is the main Web application configuration. Any writable
// CWebApplication properties can be configured here.
return array(
	'basePath'=>dirname(__FILE__).DIRECTORY_SEPARATOR.'..',
	'name'=>'Yii Forum',

	// preloading 'log' component
	'preload'=>array(
		'log',
	),

	// autoloading model and component classes
	'import'=>array(
		'application.models.*',
		'application.components.*',


	),

	'defaultController'=>'site',
	'aliases' => array(
    'xupload' => 'application.modules.sforum.components.xupload',
	),
	'modules'=>array(
	
		'sforum'=>array(
			'newTopicStatus'=>'visible', // or hidden. Description: What status should newly created topics get.
			'userClass'=>'User', //set the name of your user model
			'commentsPerPage'=>3, //number of comments per page
			'uploadDir'=>'/uploads/',// where to upload attachments
			'userUrl'=> "/user/view/id/{{userid}}", //the url to the user profiles in your project
			'imageExt'=>"jpg,gif,png,jpeg",// what extensions for attachments should be treated as images and shown in a easybox window if clicked
			'captchaLabel'=>"Drag the arrow to the right", //displayed over the  captcha for new topics


		),
		'gii'=>array(
			'class'=>'system.gii.GiiModule',
			'password'=>'admin',
		 	// If removed, Gii defaults to localhost only. Edit carefully to taste.
			'ipFilters'=>array('127.0.0.1','::1'),
		'generatorPaths' => array(
			    'ext.bootstrap.gii',

				),
		),
	),


	// application components
	'components'=>array(
	
		'user'=>array(
			// enable cookie-based authentication
			'allowAutoLogin'=>true,
		),
		/*'db'=>array(
			'connectionString' => 'sqlite:protected/data/blog.db',
			'tablePrefix' => 'tbl_',
		),*/
		// uncomment the following to use a MySQL database
		
		'db'=>array(
			'connectionString' => 'mysql:host=localhost;dbname=forum',
			'emulatePrepare' => true,
			'username' => 'root',
			'password' => '',
			'charset' => 'utf8',
			'tablePrefix' => 'tbl_',
		),
		
		'errorHandler'=>array(
			// use 'site/error' action to display errors
            'errorAction'=>'site/error',
        ),
       'urlManager'=>array(
        	'urlFormat'=>'path',
        	'rules'=>array(
        		'topic/<id:\d+>/<title:.*?>'=>'sforum/topic/view',
        		'<controller:\w+>/<action:\w+>'=>'<controller>/<action>',
        		'category/<id:\d+>/<name:.*?>'=>'sforum/category/view',

        	),
     
			'showScriptName'=>false,
			'caseSensitive'=>false, 
		),
		'log'=>array(
			'class'=>'CLogRouter',
			'routes'=>array(
				array(
					'class'=>'CFileLogRoute',
					'levels'=>'error, warning',
				),
				// uncomment the following to show log messages on web pages
				/*
				array(
					'class'=>'CWebLogRoute',
				),
				*/
			),
		),
	),

	// application-level parameters that can be accessed
	// using Yii::app()->params['paramName']
	'params'=>require(dirname(__FILE__).'/params.php'),
);