<?php

class SForumModule extends CWebModule
{
	public $defaultController = 'category';
	public $newTopicStatus;
	// set this to your url to a users profile, and put {{userid}} where the id in the url is
	public $userUrl = "/user/view/id/{{userid}}"; 
	public $userClass = 'User';
	public $commentsPerPage = 10;
	public $uploadDir = "/uploads/";
	public $imageExt = "jpg,gif,png,jpeg";
	public $captchaLabel ="Drag the arrow to the right";
	public function init()
	{
		$this->registerAssets();

		$this->setImport(array(
			'sforum.models.*',
			'sforum.components.*',
		));
	}

	//moderator/admin method
	//if this method returns true then the user will be able to delete comments,topics and move topics
	//you can change the logic of the method if you want
	public static function moderator()
	{
		if(!Yii::app()->user->isGuest)
		{
			return true;
		}else{
			return false;
		}
	}

	//if this method returns true then the user will be able to comment and reply to comments
	//you can change the logic of the method if you want
	public static function allowComment()
	{
		if(!Yii::app()->user->isGuest)
		{
			return true;
		}else{
			return false;
		}
	}

	//if this method returns true then the user will be able to create new topics
	//you can change the logic of the method if you want
	public static function allowTopic()
	{
		if(!Yii::app()->user->isGuest)
		{
			return true;
		}else{
			return false;
		}
	}
	public static function userUrl($id)
	{
		return str_replace('{{userid}}', $id, Yii::app()->controller->module->userUrl);

	} 
	
	public function beforeControllerAction($controller, $action)
	{
		if(parent::beforeControllerAction($controller, $action))
		{
			// this method is called before any module controller action is performed
			// you may place customized code here
			return true;
		}
		else
			return false;
	}

	public static function getStats()
	{
	//Stats data
		$userClass = Yii::app()->controller->module->userClass;
		$stats = array(
			'topicCount'=>Topic::model()->count(),
			'commentCount'=>Comment::model()->count(),
			'userCount'=>$userClass::model()->count(),
			);
		return $stats;
	}



	public static function parseText($text)
	{
		$text = SForumModule::urlToLink($text);
		return SForumModule::BBCode2Html($text);
	}
	public static function urlToLink($text)
	{
        $rexProtocol  = '(https?://)?';
        $rexDomain    = '(?:[-a-zA-Z0-9]{1,63}\.)+[a-zA-Z][-a-zA-Z0-9]{1,62}';
        $rexIp        = '(?:[1-9][0-9]{0,2}\.|0\.){3}(?:[1-9][0-9]{0,2}|0)';
        $rexPort      = '(:[0-9]{1,5})?';
        $rexPath      = '(/[!$-/0-9:;=@_\':;!a-zA-Z\x7f-\xff]*?)?';
        $rexQuery     = '(\?[!$-/0-9:;=@_\':;!a-zA-Z\x7f-\xff]+?)?';
        $rexFragment  = '(#[!$-/0-9:;=@_\':;!a-zA-Z\x7f-\xff]+?)?';
        $rexUsername  = '[^]\\\\\x00-\x20\"(),:-<>[\x7f-\xff]{1,64}';
        $rexPassword  = $rexUsername; 
        $rexUrl       = "$rexProtocol(?:($rexUsername)(:$rexPassword)?@)?($rexDomain|$rexIp)($rexPort$rexPath$rexQuery$rexFragment)";
        $rexUrlLinker = "{\\b$rexUrl(?=[?.!,;:\"]?(\s|$))}";

        $html = '';

        $position = 0;
        $validTlds = array_fill_keys(explode(" ", ".ac .ad .ae .aero .af .ag .ai .al .am .an .ao .aq .ar .arpa .as .asia .at .au .aw .ax .az .ba .bb .bd .be .bf .bg .bh .bi .biz .bj .bm .bn .bo .br .bs .bt .bv .bw .by .bz .ca .cat .cc .cd .cf .cg .ch .ci .ck .cl .cm .cn .co .com .coop .cr .cu .cv .cx .cy .cz .de .dj .dk .dm .do .dz .ec .edu .ee .eg .er .es .et .eu .fi .fj .fk .fm .fo .fr .ga .gb .gd .ge .gf .gg .gh .gi .gl .gm .gn .gov .gp .gq .gr .gs .gt .gu .gw .gy .hk .hm .hn .hr .ht .hu .id .ie .il .im .in .info .int .io .iq .ir .is .it .je .jm .jo .jobs .jp .ke .kg .kh .ki .km .kn .kp .kr .kw .ky .kz .la .lb .lc .li .lk .lr .ls .lt .lu .lv .ly .ma .mc .md .me .mg .mh .mil .mk .ml .mm .mn .mo .mobi .mp .mq .mr .ms .mt .mu .museum .mv .mw .mx .my .mz .na .name .nc .ne .net .nf .ng .ni .nl .no .np .nr .nu .nz .om .org .pa .pe .pf .pg .ph .pk .pl .pm .pn .pr .pro .ps .pt .pw .py .qa .re .ro .rs .ru .rw .sa .sb .sc .sd .se .sg .sh .si .sj .sk .sl .sm .sn .so .sr .st .su .sv .sy .sz .tc .td .tel .tf .tg .th .tj .tk .tl .tm .tn .to .tp .tr .travel .tt .tv .tw .tz .ua .ug .uk .us .uy .uz .va .vc .ve .vg .vi .vn .vu .wf .ws .xn--0zwm56d .xn--11b5bs3a9aj6g .xn--3e0b707e .xn--45brj9c .xn--80akhbyknj4f .xn--90a3ac .xn--9t4b11yi5a .xn--clchc0ea0b2g2a9gcd .xn--deba0ad .xn--fiqs8s .xn--fiqz9s .xn--fpcrj9c3d .xn--fzc2c9e2c .xn--g6w251d .xn--gecrj9c .xn--h2brj9c .xn--hgbk6aj7f53bba .xn--hlcj6aya9esc7a .xn--j6w193g .xn--jxalpdlp .xn--kgbechtv .xn--kprw13d .xn--kpry57d .xn--lgbbat1ad8j .xn--mgbaam7a8h .xn--mgbayh7gpa .xn--mgbbh1a71e .xn--mgbc0a9azcg .xn--mgberp4a5d4ar .xn--o3cw4h .xn--ogbpf8fl .xn--p1ai .xn--pgbs0dh .xn--s9brj9c .xn--wgbh1c .xn--wgbl6a .xn--xkc2al3hye2a .xn--xkc2dl3a5ee0h .xn--yfro4i67o .xn--ygbi2ammx .xn--zckzah .xxx .ye .yt .za .zm .zw"), true);

    while (preg_match($rexUrlLinker, $text, $match, PREG_OFFSET_CAPTURE, $position))
    {
        list($url, $urlPosition) = $match[0];

        // Add the text leading up to the URL.
        $html .= substr($text, $position, $urlPosition - $position);

        $protocol    = $match[1][0];
        $username    = $match[2][0];
        $password    = $match[3][0];
        $domain      = $match[4][0];
        $afterDomain = $match[5][0]; // everything following the domain
        $port        = $match[6][0];
        $path        = $match[7][0];

        // Check that the TLD is valid or that $domain is an IP address.
        $tld = strtolower(strrchr($domain, '.'));
        if (preg_match('{^\.[0-9]{1,3}$}', $tld) || isset($validTlds[$tld]))
        {
            // Do not permit implicit protocol if a password is specified, as
            // this causes too many errors (e.g. "my email:foo@example.org").
            if (!$protocol && $password)
            {
                $html .= $username;
                
                // Continue text parsing at the ':' following the "username".
                $position = $urlPosition + strlen($username);
                continue;
            }
            
            if (!$protocol && $username && !$password && !$afterDomain)
            {
                // Looks like an email address.
                $completeUrl = "mailto:$url";
                $linkText = $url;
            }
            else
            {
                // Prepend http:// if no protocol specified
                $completeUrl = $protocol ? $url : "http://$url";
                $linkText = "$domain$port$path";
            }
            
            $linkHtml = '<a href="' .$completeUrl . '">'
                . $linkText
                . '</a>';

            // Cheap e-mail obfuscation to trick the dumbest mail harvesters.
            $linkHtml = str_replace('@', '@', $linkHtml);
            
            // Add the hyperlink.
            $html .= $linkHtml;
        }
        else
        {
            // Not a valid URL.
            $html .= $url;
        }

        // Continue text parsing from after the URL.
        $position = $urlPosition + strlen($url);
    }

    // Add the remainder of the text.
    $html .= substr($text, $position);
    return $html;
        }

	public static function BBCode2Html($text){
// markItUp! BBCode Parser
// v 1.0.6
// Dual licensed under the MIT and GPL licenses.
// ----------------------------------------------------------------------------
// Copyright (C) 2009 Jay Salvat
// http://www.jaysalvat.com/
// http://markitup.jaysalvat.com/
// ----------------------------------------------------------------------------
// Permission is hereby granted, free of charge, to any person obtaining a copy
// of this software and associated documentation files (the "Software"), to deal
// in the Software without restriction, including without limitation the rights
// to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
// copies of the Software, and to permit persons to whom the Software is
// furnished to do so, subject to the following conditions:
// 
// The above copyright notice and this permission notice shall be included in
// all copies or substantial portions of the Software.
// 
// THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
// IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
// FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
// AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
// LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
// OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
// THE SOFTWARE.
// ----------------------------------------------------------------------------
// Thanks to Arialdo Martini, Mustafa Dindar for feedbacks.
// ----------------------------------------------------------------------------

		$text = trim($text);

		// BBCode [code]
		if (!function_exists('escape')) {
			function escape($s) {
					global $text;
					$text = strip_tags($text);
					$code = $s[1];
					$code = htmlspecialchars($code);
					$code = str_replace("[", "&#91;", $code);
					$code = str_replace("]", "&#93;", $code);
					return '<pre><code>'.$code.'</code></pre>';
				}	
			}
			$text = preg_replace_callback('/\[code\](.*?)\[\/code\]/ms', "escape", $text);

			// Smileys to find...
			$in = array( );
			// And replace them by...
			$out = array();
			$text = str_replace($in, $out, $text);
			
			// BBCode to find...
			$in = array( 	 '/\[b\](.*?)\[\/b\]/ms',	
							 '/\[i\](.*?)\[\/i\]/ms',
							 '/\[u\](.*?)\[\/u\]/ms',
							 '/\[img\](.*?)\[\/img\]/ms',
							 '/\[email\](.*?)\[\/email\]/ms',
							 '/\[url\="?(.*?)"?\](.*?)\[\/url\]/ms',
							 '/\[size\="?(.*?)"?\](.*?)\[\/size\]/ms',
							 '/\[color\="?(.*?)"?\](.*?)\[\/color\]/ms',
							 '/\[quote](.*?)\[\/quote\]/ms',
							 '/\[list\=(.*?)\](.*?)\[\/list\]/ms',
							 '/\[list\](.*?)\[\/list\]/ms',
							 '/\[\*\]\s?(.*?)\n/ms'
			);
			// And replace them by...
			$out = array(	 '<strong>\1</strong>',
							 '<em>\1</em>',
							 '<u>\1</u>',
							 '<img src="\1" alt="\1" />',
							 '<a href="mailto:\1">\1</a>',
							 '<a href="\1">\2</a>',
							 '<span style="font-size:\1%">\2</span>',
							 '<span style="color:\1">\2</span>',
							 '<blockquote>\1</blockquote>',
							 '<ol start="\1">\2</ol>',
							 '<ul>\1</ul>',
							 '<li>\1</li>'
			);
			$text = preg_replace($in, $out, $text);
				
			// paragraphs
			$text = str_replace("\r", "", $text);
			$text = "<p>".preg_replace("/(\n){2,}/", "</p><p>", $text)."</p>";
			$text = nl2br($text);
			
			// clean some tags to remain strict
			// not very elegant, but it works. No time to do better ;)
			if (!function_exists('removeBr')) {
				function removeBr($s) {
					return str_replace("<br />", "", $s[0]);
				}
			}	
			$text = preg_replace_callback('/<pre>(.*?)<\/pre>/ms', "removeBr", $text);
			$text = preg_replace('/<p><pre>(.*?)<\/pre><\/p>/ms', "<pre>\\1</pre>", $text);
			
			$text = preg_replace_callback('/<ul>(.*?)<\/ul>/ms', "removeBr", $text);
			$text = preg_replace('/<p><ul>(.*?)<\/ul><\/p>/ms', "<ul>\\1</ul>", $text);
			
			return $text;
	}

		
	public static function formatBytes($bytes, $precision = 2) { 
	    $units = array('B', 'KB', 'MB', 'GB', 'TB'); 

	    $bytes = max($bytes, 0); 
	    $pow = floor(($bytes ? log($bytes) : 0) / log(1024)); 
	    $pow = min($pow, count($units) - 1); 

	     $bytes /= pow(1024, $pow);
	    // $bytes /= (1 << (10 * $pow)); 

	    return round($bytes, $precision) . ' ' . $units[$pow]; 
	} 

	public function registerAssets()
	{	
		$assets =Yii::app()->basePath.'/modules/sforum/assets';
		$baseUrl = Yii::app() -> assetManager -> publish($assets);
		//the css to use

		Yii::app() -> clientScript -> registerCssFile($baseUrl . '/css/bootstrap-responsive.min.css');
		Yii::app() -> clientScript -> registerCssFile($baseUrl . '/css/bootstrap-yii.css');
		Yii::app() -> clientScript -> registerCssFile($baseUrl . '/css/bootstrap.min.css');
		Yii::app() -> clientScript -> registerCssFile($baseUrl . '/css/sforum.css');
		Yii::app() -> clientScript -> registerCssFile($baseUrl . '/css/visualize.css');
		Yii::app() -> clientScript -> registerCssFile($baseUrl . '/css/visualize-light.css');
		Yii::app() -> clientScript -> registerCssFile($baseUrl . '/easybox/easybox.min.css');
		Yii::app() -> clientScript -> registerCssFile($baseUrl . '/css/jquery.toastmessage.css');
		Yii::app() -> clientScript -> registerCssFile($baseUrl . '/markitup/skins/markitup/style.css');
		Yii::app() -> clientScript -> registerCssFile($baseUrl . '/markitup/sets/bbcode/style.css');

		// the js to use
		Yii::app()->getClientScript()->registerCoreScript( 'jquery.ui' );
		Yii::app() -> clientScript -> registerScriptFile($baseUrl . "/js/jquery.confirm-dialog.js", CClientScript::POS_BEGIN);
		Yii::app() -> clientScript -> registerScriptFile($baseUrl . "/js/QapTcha.jquery.min.js", CClientScript::POS_BEGIN);
		Yii::app() -> clientScript -> registerScriptFile($baseUrl . "/easybox/easybox.min.js", CClientScript::POS_BEGIN);
		Yii::app() -> clientScript -> registerScriptFile($baseUrl . "/js/visualize.jQuery.js", CClientScript::POS_BEGIN);
		Yii::app() -> clientScript -> registerScriptFile($baseUrl . "/js/jquery.toastmessage.js", CClientScript::POS_END);
		Yii::app() -> clientScript -> registerScriptFile($baseUrl . "/js/jquery.validate.min.js", CClientScript::POS_BEGIN);
		Yii::app() -> clientScript -> registerScriptFile($baseUrl . "/js/jquery.jeditable.min.js", CClientScript::POS_BEGIN);
		Yii::app() -> clientScript -> registerScriptFile($baseUrl . "/js/bpopup.js", CClientScript::POS_END);
		Yii::app() -> clientScript -> registerScriptFile($baseUrl . "/js/sforum.js", CClientScript::POS_END);
		Yii::app() -> clientScript -> registerScriptFile($baseUrl . "/markitup/sets/bbcode/set.js", CClientScript::POS_BEGIN);
		Yii::app() -> clientScript -> registerScriptFile($baseUrl . "/markitup/jquery.markitup.js", CClientScript::POS_BEGIN);
	}
}
