<?php

class AdminController extends Controller
{
	/**
	 * @return array action filters
	 */
	public function filters()
	{
		return array(
			'accessControl', // perform access control for CRUD operations
		);
	}

	/**
	 * Specifies the access control rules.
	 * This method is used by the 'accessControl' filter.
	 * @return array access control rules
	 */
	public function accessRules()
	{
		return array(
			
			array('allow', 
				'actions'=>array('index','delete'),
				'users'=>array('@'),
			),		
			array('deny',  // deny all users
				'users'=>array('*'),
			),
		);
	}

	public function allowedActions(){
		return "";
	}
	public function actionIndex()
	{
		$this->layout = "forum";
		$category=new Category('search');
		$category->unsetAttributes();  // clear any default values
		if(isset($_GET['Category']))
			$category->attributes=$_GET['Category'];
		if(Yii::app()->request->isAjaxRequest)
		{
			$this->renderPartial('index',array('category'=>$category));
		}else{
			$this->render('index',array('category'=>$category));
		}
	}

	/* Delete topics or comments*/
	public function actionDelete()
	{
		$modelClass = $_POST['modelClass'];
		$id = $_POST['id'];
		if(Yii::app()->request->isAjaxRequest && Yii::app()->request->isPostRequest)
		{
			// we only allow deletion via POST request
			if($modelClass::model()->findByPk($id)->delete())
			{
				echo CJSON::encode(array('status'=>'success'));
			}else{
				echo CJSON::encode(array('status'=>'Failed to delete'));
			}
		}
		else
			throw new CHttpException(400,'Invalid request. Please do not repeat this request again.');
	}

}